<?php

// Mike Crowe new language mod -------------------------------------------------------------------------------
/*
CREATE TABLE `lang_keys` (
  `kmodule` varchar(32) NOT NULL default '',
  `ktype` varchar(32) NOT NULL default '',
  `karray` varchar(32) NOT NULL default '',
  `kkey` varchar(80) NOT NULL default '',
  `default` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`kmodule`,`ktype`,`karray`,`kkey`),
  KEY `kmodule` (`kmodule`),
  KEY `karray` (`kmodule`,`karray`),
  KEY `kkey` (`kkey`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;*/

function vt_t($string,$karray,$kkey)
{
	$res = _($string);
	if ( $res == "" )
	{
		$res = "**$karray/$kkey**";
	}
	return $res;
}

function get_db_language($language, $module)
{
	global $adb,$lang_loaded,$app_strings,$app_list_strings,$current_language,$mod_strings;
	
	if ( $language == "" ) $language="en_US";
	putenv ('LANGUAGE='.$language);
	setlocale(LC_ALL, $language);
	// search for translations to messages passed to gettext
	bindtextdomain ('messages', './locale');
	bind_textdomain_codeset('messages','UTF-8');
	// Set the current domain that gettext will use
	textdomain ('messages');	
	$strings = array();
	$list_strings = array();
	$adb->query("SET CHARACTER SET utf8");
	$adb->query("SET NAMES 'utf8'");	
	$sql = "SELECT * FROM lang_keys WHERE kmodule='$module' AND karray='*'";
	$rs = $adb->query($sql);
	while ( $res = $adb->fetch_array($rs) )
	{		
		if ( $res["ktype"] == "app_strings" || $res["ktype"] == "mod_strings" )
			$strings[$res["kkey"]] = vt_t($res["default_value"],"",$res["kkey"]);
		else
			$list_strings[$res["kkey"]] = vt_t($res["default_value"],"",$res["kkey"]);		
	}

	if ( count($strings) <= 1 )
		return $lang_loaded = null;
	$sql = "SELECT * FROM lang_keys WHERE kmodule='$module' AND karray!='*'";
	$rs = $adb->query($sql);
	while ( $res = $adb->fetch_array($rs) )
	{
		if ( $res["ktype"] == "app_strings" || $res["ktype"] == "mod_strings" )
			$strings[$res["karray"]][] = vt_t($res["default_value"],$res["karray"],$res["kkey"]);
		else
			$list_strings[$res["karray"]][$res["kkey"]] = vt_t($res["default_value"],$res["karray"],$res["kkey"]);
	}
	
	$lang_loaded = $current_language = $language;
	if ( $module == "Application" )
	{
		$app_strings = $strings;
		$app_list_strings = $list_strings;
	}
	elseif ( count($list_strings) > 0 )
	{
		$log->fatal("didn't expect this:  array",$module,$list_strings,$strings);
		die;
	}
	else
		$mod_strings = $strings;
}

function return_app_list_strings_language($language)
{
	global $lang_loaded,$app_list_strings,$log,$default_language;
	
	if ( !isset($lang_loaded) )
		get_db_language($language, "Application");
	if ( !isset($lang_loaded) )
	{
		$log->warn("Unable to find the application language file for language: ".$language);
		get_db_language($default_language, "Application");
	}
	if ( !isset($lang_loaded) )
	{
		$log->fatal("Unable to load the application language file for the selected language($language) or the default language($default_language)");
		return null;
	}
	return $app_list_strings;
}

function return_application_language($language)
{
	global $lang_loaded,$app_strings,$log;
	
	if ( !isset($lang_loaded) )
		get_db_language($language, "Application");
	if ( !isset($lang_loaded) )
	{
		$log->warn("Unable to find the application language file for language: ".$language);
		get_db_language($default_language, "Application");
	}
	if ( !isset($lang_loaded) )
	{
		$log->fatal("Unable to load the application language file for the selected language($language) or the default language($default_language)");
		return null;
	}
	return $app_strings;
}

function return_module_language($language, $module)
{
	global $mod_strings;
	
	get_db_language($language,$module);	
	return $mod_strings;
}
// Mike Crowe new language mod -------------------------------------------------------------------------------

?>
